Module javafx.controls
Package javafx.scene.control

# Class TextField

java.lang.Object
javafx.scene.Node
javafx.scene.Parent
javafx.scene.layout.Region
javafx.scene.control.Control
javafx.scene.control.TextInputControl
javafx.scene.control.TextField

All Implemented Interfaces:
  `Styleable`, `EventTarget`, `Skinnable`

Direct Known Subclasses:
  `PasswordField`

public class TextField extends TextInputControl
Text input component that allows a user to enter a single line of unformatted text. Unlike in previous releases of JavaFX, support for multi-line input is not available as part of the TextField control, however this is the sole-purpose of the `TextArea` control. Additionally, if you want a form of rich-text editing, there is also the `HTMLEditor` control.

TextField supports the notion of showing `prompt text` to the user when there is no `text` already in the TextField (either via the user, or set programmatically). This is a useful way of informing the user as to what is expected in the text field, without having to resort to `tooltips` or on-screen `labels`.

Since:
  JavaFX 2.0
See Also:
  - `TextArea`

## Property Summary

Properties
Type
Property
Description
`final ObjectProperty<Pos>`
`alignment`
Specifies how the text should be aligned when there is empty space within the TextField.
`final ObjectProperty<EventHandler<ActionEvent>>`
`onAction`
The action handler associated with this text field, or `null` if no action handler is assigned.
`final IntegerProperty`
`prefColumnCount`
The preferred number of text columns.

### Properties inherited from class javafx.scene.control.TextInputControl

`anchor, caretPosition, editable, font, length, promptText, redoable, selectedText, selection, textFormatter, text, undoable`

### Properties inherited from class javafx.scene.control.Control

`contextMenu, skin, tooltip`

### Properties inherited from class javafx.scene.layout.Region

`background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

### Properties inherited from class javafx.scene.Parent

`needsLayout`

### Properties inherited from class javafx.scene.Node

`accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

## Nested Class Summary

## Nested classes/interfaces inherited from class javafx.scene.control.TextInputControl

`TextInputControl.Content`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`DEFAULT_PREF_COLUMN_COUNT`
The default value for `prefColumnCount`.

### Fields inherited from class javafx.scene.layout.Region

`USE_COMPUTED_SIZE, USE_PREF_SIZE`

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

## Constructor Summary

Constructors
Constructor
Description
`TextField()`
Creates a `TextField` with empty text content.
`TextField(String text)`
Creates a `TextField` with initial text content.

## Method Summary

Modifier and Type
Method
Description
`final ObjectProperty<Pos>`
`alignmentProperty()`
Specifies how the text should be aligned when there is empty space within the TextField.
`protected Skin<?>`
`createDefaultSkin()`
Create a new instance of the default skin for this control.
`final Pos`
`getAlignment()`
Gets the value of the `alignment` property.
`CharSequence`
`getCharacters()`
Returns the character sequence backing the text field's content.
`static List<CssMetaData<? extends Styleable,?>>`
`getClassCssMetaData()`
`List<CssMetaData<? extends Styleable,?>>`
`getControlCssMetaData()`
`final EventHandler<ActionEvent>`
`getOnAction()`
Gets the value of the `onAction` property.
`final int`
`getPrefColumnCount()`
Gets the value of the `prefColumnCount` property.
`final ObjectProperty<EventHandler<ActionEvent>>`
`onActionProperty()`
The action handler associated with this text field, or `null` if no action handler is assigned.
`final IntegerProperty`
`prefColumnCountProperty()`
The preferred number of text columns.
`final void`
`setAlignment(Pos value)`
Sets the value of the `alignment` property.
`final void`
`setOnAction(EventHandler<ActionEvent> value)`
Sets the value of the `onAction` property.
`final void`
`setPrefColumnCount(int value)`
Sets the value of the `prefColumnCount` property.

### Methods inherited from class javafx.scene.control.TextInputControl

`anchorProperty, appendText, backward, cancelEdit, caretPositionProperty, clear, commitValue, copy, cut, deleteNextChar, deletePreviousChar, deleteText, deleteText, deselect, editableProperty, end, endOfNextWord, executeAccessibleAction, extendSelection, fontProperty, forward, getAnchor, getCaretPosition, getContent, getFont, getLength, getPromptText, getSelectedText, getSelection, getText, getText, getTextFormatter, home, insertText, isEditable, isRedoable, isUndoable, lengthProperty, nextWord, paste, positionCaret, previousWord, promptTextProperty, queryAccessibleAttribute, redo, redoableProperty, replaceSelection, replaceText, replaceText, selectAll, selectBackward, selectedTextProperty, selectEnd, selectEndOfNextWord, selectForward, selectHome, selectionProperty, selectNextWord, selectPositionCaret, selectPreviousWord, selectRange, setEditable, setFont, setPromptText, setText, setTextFormatter, textFormatterProperty, textProperty, undo, undoableProperty`

### Methods inherited from class javafx.scene.control.Control

`computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, contextMenuProperty, getBaselineOffset, getContextMenu, getCssMetaData, getInitialFocusTraversable, getSkin, getTooltip, isResizable, layoutChildren, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

### Methods inherited from class javafx.scene.layout.Region

`backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

### Methods inherited from class javafx.scene.Parent

`getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

## Property Details

### prefColumnCount

public final IntegerProperty prefColumnCountProperty
The preferred number of text columns. This is used for calculating the `TextField`'s preferred width.

See Also:
  - `getPrefColumnCount()`
  - `setPrefColumnCount(int)`
  - `prefColumnCountProperty()`

### onAction

public final ObjectProperty<EventHandler<ActionEvent>> onActionProperty
The action handler associated with this text field, or `null` if no action handler is assigned. The action handler is normally called when the user types the ENTER key.

See Also:
  - `getOnAction()`
  - `setOnAction(EventHandler)`
  - `onActionProperty()`

### alignment

public final ObjectProperty<Pos> alignmentProperty
Specifies how the text should be aligned when there is empty space within the TextField.

Since:
  JavaFX 2.1
See Also:
  - `getAlignment()`
  - `setAlignment(Pos)`
  - `alignmentProperty()`

## Field Details

### DEFAULT_PREF_COLUMN_COUNT

public static final int DEFAULT_PREF_COLUMN_COUNT
The default value for `prefColumnCount`.

See Also:
  - Constant Field Values

## Constructor Details

### TextField

public TextField()
Creates a `TextField` with empty text content.

### TextField

public TextField(String text)
Creates a `TextField` with initial text content.

Parameters:
  `text` - A string for text content.

## Method Details

### getCharacters

public CharSequence getCharacters()
Returns the character sequence backing the text field's content.

Returns:
  the character sequence backing the text field's content

### prefColumnCountProperty

public final IntegerProperty prefColumnCountProperty()
The preferred number of text columns. This is used for calculating the `TextField`'s preferred width.

Returns:
  the `prefColumnCount` property
See Also:
  - `getPrefColumnCount()`
  - `setPrefColumnCount(int)`

### getPrefColumnCount

public final int getPrefColumnCount()
Gets the value of the `prefColumnCount` property.

Property description:
  The preferred number of text columns. This is used for calculating the `TextField`'s preferred width.
Returns:
  the value of the `prefColumnCount` property
See Also:
  - `setPrefColumnCount(int)`
  - `prefColumnCountProperty()`

### setPrefColumnCount

public final void setPrefColumnCount(int value)
Sets the value of the `prefColumnCount` property.

Property description:
  The preferred number of text columns. This is used for calculating the `TextField`'s preferred width.
Parameters:
  `value` - the value for the `prefColumnCount` property
See Also:
  - `getPrefColumnCount()`
  - `prefColumnCountProperty()`

### onActionProperty

public final ObjectProperty<EventHandler<ActionEvent>> onActionProperty()
The action handler associated with this text field, or `null` if no action handler is assigned. The action handler is normally called when the user types the ENTER key.

Returns:
  the `onAction` property
See Also:
  - `getOnAction()`
  - `setOnAction(EventHandler)`

### getOnAction

public final EventHandler<ActionEvent> getOnAction()
Gets the value of the `onAction` property.

Property description:
  The action handler associated with this text field, or `null` if no action handler is assigned. The action handler is normally called when the user types the ENTER key.
Returns:
  the value of the `onAction` property
See Also:
  - `setOnAction(EventHandler)`
  - `onActionProperty()`

### setOnAction

public final void setOnAction(EventHandler<ActionEvent> value)
Sets the value of the `onAction` property.

Property description:
  The action handler associated with this text field, or `null` if no action handler is assigned. The action handler is normally called when the user types the ENTER key.
Parameters:
  `value` - the value for the `onAction` property
See Also:
  - `getOnAction()`
  - `onActionProperty()`

### alignmentProperty

public final ObjectProperty<Pos> alignmentProperty()
Specifies how the text should be aligned when there is empty space within the TextField.

Returns:
  the alignment property
Since:
  JavaFX 2.1
See Also:
  - `getAlignment()`
  - `setAlignment(Pos)`

### setAlignment

public final void setAlignment(Pos value)
Sets the value of the `alignment` property.

Property description:
  Specifies how the text should be aligned when there is empty space within the TextField.
Parameters:
  `value` - the value for the `alignment` property
Since:
  JavaFX 2.1
See Also:
  - `getAlignment()`
  - `alignmentProperty()`

### getAlignment

public final Pos getAlignment()
Gets the value of the `alignment` property.

Property description:
  Specifies how the text should be aligned when there is empty space within the TextField.
Returns:
  the value of the `alignment` property
Since:
  JavaFX 2.1
See Also:
  - `setAlignment(Pos)`
  - `alignmentProperty()`

### createDefaultSkin

protected Skin<?> createDefaultSkin()
Create a new instance of the default skin for this control. This is called to create a skin for the control if no skin is provided via CSS `-fx-skin` or set explicitly in a sub-class with `setSkin(...)`.

Overrides:
  `createDefaultSkin` in class `Control`
Returns:
  new instance of default skin for this control. If null then the control will have no skin unless one is provided by css.

### getClassCssMetaData

public static List<CssMetaData<? extends Styleable,?>> getClassCssMetaData()

Returns:
  The CssMetaData associated with this class, which may include the CssMetaData of its superclasses.
Since:
  JavaFX 8.0

### getControlCssMetaData

public List<CssMetaData<? extends Styleable,?>> getControlCssMetaData()

Overrides:
  `getControlCssMetaData` in class `TextInputControl`
Returns:
  unmodifiable list of the controls css styleable properties
Since:
  JavaFX 8.0